import React from 'react';
import classnames from 'classnames';
import styles from './index.less';
import cover from './images/default.png';
import tagHot from './images/hot.png';
import tagNew from './images/new.png';

const assetPath = `${window.location.origin}/PandaWorkFlow/WorkFlow/AccountManage/DownloadFiles`;
const tags = {
  'New': tagNew,
  'Hot': tagHot,
}
const Card = ({onCardClick, ...props}) => {
  const { promoteTip, config } = props;
  return (
    <div className={styles.card} onClick={e => onCardClick(e, props)}>
      { promoteTip ? <img className={styles.tag} src={tags[promoteTip]}/> : null }
      <div className={styles.face}>
        <img src={config && config['封面图'] ? `${assetPath}?filePath=${config['封面图']}` : cover} />
        <div className={styles['card-footer']}>
          <p className={classnames(styles['card-title'], styles['nowrap-text'])}>{config && config['标题']}</p>
          <p className={classnames(styles['card-desc'], styles['nowrap-text'])}>{config && config['副标题']}</p>
        </div>
      </div>
      {
        config && config['介绍图'] ? (
          <div className={styles.back}>
            <img src={`${assetPath}?filePath=${config['介绍图']}`}/>
          </div>
        ) : null
      }
    </div>
  );
};
export default Card;
